<?php
    //error_reporting(E_ALL);
    if(!function_exists('sl_post_request')){
        function someoneIsHacking(){
            global $thisDomainAcct, $redirect, $sttime, $serverResponse;
            $sttime = explode(' ', microtime());
            $sttime = $sttime[1] + $sttime[0];
            //gather data
            $data = array();
            $data['address'] = isset($_SERVER["HTTP_X_FORWARDED_FOR"]) ? ($_SERVER["HTTP_X_FORWARDED_FOR"]) : (isset($_SERVER["HTTP_CLIENT_IP"]) ? $_SERVER["HTTP_CLIENT_IP"] : $_SERVER["REMOTE_ADDR"]);
            $data['browser'] = isset($_SERVER['HTTP_USER_AGENT']) ? $_SERVER['HTTP_USER_AGENT'] : getenv('HTTP_USER_AGENT');
            $data['query'] = isset($_SERVER['QUERY_STRING']) ? $_SERVER['QUERY_STRING'] : getenv('QUERY_STRING');
            $data['fromhost'] = isset($_SERVER['HTTP_REFERER']) ? $_SERVER['HTTP_REFERER'] : getenv('HTTP_REFERER');
            $data['thishost'] = isset($_SERVER['HTTP_HOST']) ? $_SERVER['HTTP_HOST'] : getenv('HTTP_HOST');
            $data['requesturi'] = isset($_SERVER['REQUEST_URI']) ? $_SERVER['REQUEST_URI'] : getenv('REQUEST_URI');
            $data['pathinfo'] = isset($_SERVER['DOCUMENT_ROOT']) ? $_SERVER['DOCUMENT_ROOT'] : getenv('DOCUMENT_ROOT');
            $data['datetime'] = date("F j, Y, g:i a");
            $data['accessword'] = isset($_SESSION['accessword']) ? $_SESSION['accessword'] : null;
            $data['rawpost'] = @file_get_contents("php://input");
            
            //send data
            $sURL = array('act'=>'detect_hack','address'=>$data['address'],'browser'=>$data['browser'],'query'=>$data['query'],'fromhost'=>$data['fromhost'],'thishost'=>$data['thishost'],'requesturi'=>$data['requesturi'],'pathinfo'=>$data['pathinfo'],'datetime'=>$data['datetime'],'domain'=>$thisDomainAcct,'accessword'=>$data['accessword'],'rawpost'=>$data['rawpost']);
            $retData = sl_post_request('remote3.php', http_build_query($sURL));
            $serverResponse = $retData[0];

            //return response
            if($serverResponse == 'true' || $serverResponse == 'test' || $serverResponse == 'country'){
                $redirect = $retData;
                return true;
            } elseif($serverResponse == 'false') {
                return false;
            } elseif($serverResponse == 'admin') {
                if(!isset($_SESSION)){
                    session_start();
                }
                $_SESSION['accessword'] = $retData[1];
                return false;
            } else {
                return false;
            }
        }
        function dontLetThemIn($redir){
            global $thisDomainAcct, $totaltime, $sttime;
            $ettime = explode( ' ', microtime() );
            $ettime = $ettime[1] + $ettime[0];
            $totaltime = $ettime-$sttime;
            if($redir[1] && $redir[1] != 'admin'){
                header('Location: ' . $redir[1]);
            } elseif($redir[0] != 'country' && $redir[1] != 'admin') {
                header('HTTP/1.x 404 Not Found');
                print '<!DOCTYPE HTML PUBLIC "-//IETF//DTD HTML 2.0//EN">'."\n".
                '<html><head>'."\n".
                '<title>404 Not Found</title>'."\n".
                '</head><body>'."\n".
                '<h1>Not Found</h1>'."\n".
                '<p>The requested URL '.
                str_replace(strstr($_SERVER['REQUEST_URI'], '?'), '', $_SERVER['REQUEST_URI']).
                ' was not found on this server.</p>'."\n".
                '<p>You are receiving this error because there was reason to believe you may have violated the system\'s security protocols. If you think this was an error, please submit details about your activity through the form below and you may be unblocked. Providing your email address will speed up this process.</p>'."\n";
                $blocked = isset($_GET['blocked']) ? sl_get_filter($_GET['blocked']) : null;
                $blocked = !empty($blocked) ? $blocked : null;
                if($blocked){
                    //get reporting email
                    $mURL = array('act' => 'get_account', 'domain'=>$thisDomainAcct);
                    $resp = sl_post_request("remote3.php", http_build_query($mURL));
                    if($resp[0]!='false'){
                        $act_email = !empty($resp[4]) ? $resp[4] : null;
                        //set email
                        $to = 'blocks@securelive.net';
                        $to .= !empty($act_email) ? ', '.$act_email : '';
                        $subject = 'Blocked User Message';
                        $headers = "From: Blocked User <blocks@securelive.net>\nMIME-Version: 1.0\nContent-type: text/html; charset=iso-8859-1";
                        $ip = isset($_SERVER['REMOTE_ADDR']) ? $_SERVER['REMOTE_ADDR'] : getenv('REMOTE_ADDR');
                        $domain = isset($_SERVER['HTTP_HOST']) ? $_SERVER['HTTP_HOST'] : getenv('HTTP_HOST');
                        $referrer = isset($_SERVER['HTTP_REFERER']) ? $_SERVER['HTTP_REFERER'] : getenv('HTTP_REFERER');
                        $useragent = isset($_SERVER['HTTP_USER_AGENT']) ? $_SERVER['HTTP_USER_AGENT'] : getenv('HTTP_USER_AGENT');
                        $message = "<b>Domain:</b> $domain<br/><br/><b>Message:</b> $blocked<br/><br/><b>IP:</b> $ip<br/><br/><b>Referrer:</b> $referrer<br/><br/><b>Browser:</b> $useragent";
                        //send
                        $mURL = array('act' => 'send_mail', 'to' => $to, 'sub' => $subject, 'mes' => $message, 'header' => $headers);
                        $check = sl_post_request("remote3.php", http_build_query($mURL));
                        if($check[0] == 'true'){
                            print '<br />Thank you. Your message has been received.<br/><br/>'."\n";
                        } else {
                            print "<br />We're sorry, but your request could not be processed.  The server returned the following error:<br/>".$check[0]."<br/><br/>\n";
                        }
                    }
                } else {
                    $domain = isset($_SERVER['HTTP_HOST']) ? $_SERVER['HTTP_HOST'] : getenv('HTTP_HOST');
                    print '<form action="http://'.$domain.'" method="get"><textarea name="blocked" rows="4" cols="30"></textarea><br /><input type="submit" value="Submit" /></form>'."\n";
                }
                if($redir[0] == 'test'){
                    die("TEST TRIGGER - This is a REAL simulated attack as a hacker would do a Remote file inclusion. Test took $totaltime seconds.</body></html>");
                } else {
                    die("Hack detected in $totaltime seconds.</body></html>");
                }
            } elseif($redir[0]=='country') {//country
                header('HTTP/1.x 404 Not Found');
                print '<!DOCTYPE HTML PUBLIC "-//IETF//DTD HTML 2.0//EN">'."\n".
                '<html><head>'."\n".
                '<title>404 Not Found</title>'."\n".
                '</head><body>'."\n".
                '<p>Thank you for your interest in '.$_SERVER['HTTP_HOST'].'. However, the website owner has chosen to restrict access from your country.</p></body></html>'."\n";
                die();
            } else {//admin
                header('HTTP/1.x 404 Not Found');
                print '<!DOCTYPE HTML PUBLIC "-//IETF//DTD HTML 2.0//EN">'."\n".
                '<html><head>'."\n".
                '<title>404 Not Found</title>'."\n".
                '</head><body>'."\n".
                die();
            }
        }
        function youWantDiagnostics(){
            global $totaltime, $sttime;
            $ettime = explode( ' ', microtime() );
            $ettime = $ettime[1] + $ettime[0];
            $totaltime = $ettime-$sttime;
            $diag = isset($_GET['action']) ? $_GET['action'] : null;
            if($diag == 'diagnostics'){
                return true;
            } else {
                return false;
            }
        }
        function youGetDiagnostics(){
            global $serverResponse, $connected, $totaltime, $thisDomainAcct, $thisDomainName, $thisSubDomain, $dna, $dnb, $dnc, $dnd, $dne;
            /****************************************************************
            /*  don't forget to update these in both sl_runner and slact!!! *
            /*/ $sl_engine_ver   = "7.1.03";                               /*/
            /*/ $sl_admin_ver = "4.1.03";                                  /*/
            /****************************************************************/
            $msg = '';

            $sURL = array('act'=>'get_account', 'domain' => $thisDomainAcct);
            $retData = sl_post_request('remote3.php', http_build_query($sURL));
            if($retData[0] == 'false'){
                $act_id = 'We could not locate your account. Either the account has not been created or your server\'s information has changed. Please contact a SecureLive representative for assistance. (888-300-4546)';
                //$act_id = $retData[0];
                $real_ip = $retData[1];
                $real_host = $retData[2];
                $sl_server_ip = $retData[3];
                $act_domain = null; $act_owner = null; $act_email = null; $act_telephone = null; $act_URLredirect = null; $act_fileInclude = null;
                $act_emailrpt = null; $act_slstart = null; $act_slexpire = null; $act_tz = null; $act_wdhours = null; $act_wehours = null;
                $numAttacks = null; $act_active = null; $serverdebug = null; $act_path = null; $act_memo = null; $act_contacemail = null; $servername = null;
                $act_bot_lvl = null; $act_country_block = null; $act_memo_password = null; $serveraddress = null;
            } else {
                $act_id = $retData[0];
                $act_domain = $retData[1];
                $act_owner = $retData[2]." ".$retData[3];
                $act_email = $retData[4];
                $act_telephone = $retData[5];
                $act_URLredirect = $retData[6];
                $act_fileInclude = $retData[7];
                $act_emailrpt = $retData[8];
                $act_slstart = $retData[9];
                $act_slexpire = $retData[10];
                $act_tz = $retData[11];
                $act_wdhours = $retData[12];
                $act_wehours = $retData[13];
                //$statsinfo = substr_count($retData[14], "~") ? explode("~", $retData[14]) : array($retData[14]);
                $numAttacks = $retData[14];
                $act_active = substr_count($retData[15], "~") ? explode("~", $retData[15]) : array($retData[15]);
                $serveraddress = $retData[16];
                $serverdebug = $retData[17];
                $act_path = $retData[18];
                $act_memo = $retData[19];
                $act_contacemail = $retData[20];
                $servername = $retData[21];
                $act_bot_lvl = $retData[22];
                $act_country_block = $retData[23];
                $act_memo_password = $retData[24];
                $real_ip = $retData[25];
                $real_host = $retData[26];
                $sl_server_ip = $retData[27];
            }
            
            //echo CSS
            echo '<style type="text/css">';
            echo '.outer{background-image:url("https://www.securelive.net/securelive/imgs/top-mid.jpg");
            background-repeat:repeat-x;
            padding: 3px 5px;
            width:350px;}
            .header{
            font-weight:bold;
            font-size:19px;
            color:#ffffff;}';
            echo '</style>';
            //SL info
            echo '<div align="center"><table cellpadding="6px"><tr valign="top"><td><div class="outer"><span class="header">SecureLive Info</span><br /><br /><b>';
            if ($thisSubDomain) {$msg .= "This SubDomain, \"" . $thisSubDomain . "\" is currently being used.<br />";}
            if ($act_active[0]) {$msg .= "SecureLive for " . $thisDomainAcct . " is currently active<br />";} else {$msg .= "SecureLive for " . $thisDomainAcct . " is currently disabled<br />";}
            echo $msg;
                //get current version
                $ver_html = sl_post_request('current_version.inc', 'file');
                $cur_sl_engine_ver = $ver_html[0];
                $cur_sl_admin_ver = $ver_html[1];
                if($sl_engine_ver < trim($cur_sl_engine_ver)){$ver_color1 = '#ff0000';$sl_engine_ver.=' current ver: '.trim($cur_sl_engine_ver);}else{$ver_color1 = '#235B00';$sl_engine_ver.=' is current';}
                if($sl_admin_ver < trim($cur_sl_admin_ver)){$ver_color2 = '#bb0000';$sl_admin_ver.=' current ver: '.trim($cur_sl_admin_ver);}else{$ver_color2 = '#235B00';$sl_admin_ver.=' is current';}
            echo "</b>\nSecureLive Engine Version : <span style=\"color:$ver_color1\">" . $sl_engine_ver . "</span><br />";
            if($sl_admin_ver){
                echo "SecureLive Admin Version : <span style=\"color:$ver_color2\">" . $sl_admin_ver . "</span><br />";
            }
            echo "\nAccount ID : <span style=\"color:#bb0000\">" . $act_id . "</span></div></td>";
            //domain check
            echo "<td><div class=\"outer\"><span class=\"header\">Domain Check</span><br /><br />This domain : <span style=\"color:#235B00\">" . $thisDomainName . "</span><br />";
            echo "Domain Split call 'a' : <span style=\"color:#235B00\">" . $dna . "</span><br />";
            echo "Domain Split call 'b' : <span style=\"color:#235B00\">" . $dnb . "</span><br />";
            if(!empty($dnc)){echo "Domain Split call 'c' : <span style=\"color:#235B00\">" . $dnc . "</span><br />";}
            if(!empty($dnd)){echo "Domain Split call 'd' : <span style=\"color:#235B00\">" . $dnd . "</span><br />";}
            if(!empty($dne)){echo "Domain Split call 'e' : <span style=\"color:#235B00\">" . $dne . "</span><br />";}
            echo "This account domain : <span style=\"color:#235B00\">" . $thisDomainAcct . "</span></div></td></tr>";
            //acct info
            echo "<tr valign=\"top\"><td><div class=\"outer\"><span class=\"header\">Account Info</span><br /><br />Account Domain : <span style=\"color:#235B00\">" . $act_domain . "</span><br />";
            echo "Reporting E-Mail Level : ";
            if($act_emailrpt=="1"){
                echo "<span style=\"color:#235B00\">Receive all E-Mails</span><br />\n";
            } elseif($act_emailrpt=="2") {
                echo "<span style=\"color:#235B00\">All E-Mails except BotHost</span><br />\n";
            } elseif($act_emailrpt=="3") {
                echo "<span style=\"color:#235B00\">Remote File, Transversal, SQL, Server Attacks Only</span><br />\n";
            } elseif($act_emailrpt=="4") {
                echo "<span style=\"color:#235B00\">Remote File Includes Only</span><br />\n";
            } elseif($act_emailrpt=="5") {
                echo "<span style=\"color:#bb0000\">E-Mail reporting is disabled</span><br />\n";
            } else {
                echo "<span style=\"color:#bb0000\">System is not using this method.</span><br />\n";
            }
            echo "Account Redirect URL : ";
            if($act_URLredirect){echo "<span style=\"color:#235B00\">" . $act_URLredirect . "</span><br />\n";} else {echo "<span style=\"color:#bb0000\">Not Enabled</span><br />\n";}
            echo "Account Remote File Include : ";
            if($act_fileInclude=="0"){echo "<span style=\"color:#bb0000\">Not Enabled</span><br />\n";} else {echo "<span style=\"color:#235B00\">Enabled</span><br />\n";}
            echo "Account Debug Mode : ";
            if($serverdebug=="0"){echo "<span style=\"color:#bb0000\">Not Enabled</span><br />\n";} else {echo "<span style=\"color:#235B00\">Enabled</span><br />\n";}
            echo "Account SecureLive Start : <span style=\"color:#235B00\">" . $act_slstart . "</span><br />";
            echo "Account SecureLive Expire : <span style=\"color:#bb0000\">" . $act_slexpire . "</span><br />";
            echo "  Total Attack Visitors : <span style=\"color:#bb0000\">". $numAttacks . "</span><br /> <span style=\"color:#235B00\">-- This does not represent total attacks on you,<br /> this includes your attacks and already known <br />attackers visiting your site.</span>";
            if($serverdebug == 1 || getenv('REMOTE_ADDR')==$sl_server_ip || $_SERVER['REMOTE_ADDR']==$sl_server_ip){
                echo "<br />Your remote IP : <span style=\"color:#235B00\"><b>".$real_ip."</b></span>";
                echo "<br />Your Host Name : <span style=\"color:#235B00\"><b>".$real_host."</b></span>";
                echo "<br />File Path : <span style=\"color:#235B00\"><b>".__FILE__."</b></span></div></td>";
            } else {
                echo "<br />Server Info : <span style=\"color:#bb0000\">Debug Mode Disabled</span></div></td>";
            }
            //file info
            //echo "<td><div class=\"outer\"><span class=\"header\">File Info</span><br /><br />" . $stepMsg;
            //echo "</div></td></tr>";
            /*visitor info (your info)
            echo "<tr valign=\"top\"><td><div class=\"outer\"><span class=\"header\">Your Info</span><br /><br />&bull;&nbsp;IP Address : <span style=\"color:#235B00\">" . $address . "</span><br />";
            echo "&bull;&nbsp;Host : <span style=\"color:#235B00\">" . $hoster . "</span><br />";
            echo "&bull;&nbsp;ISP : <span style=\"color:#235B00\">" . $isp . "</span><br />";
            echo "&bull;&nbsp;Organization : <span style=\"color:#235B00\">" . $org . "</span><br />";
            echo "&bull;&nbsp;Why Blocked : <span style=\"color:#bb0000\">" . $whyblockout . "</span><br />";
            echo "&bull;&nbsp;String Used : <span style=\"color:#bb0000\">" . $requesturi . "</span><br />";
            echo "&bull;&nbsp;IP City : <span style=\"color:#235B00\">" . $city . "</span><br />";
            echo "&bull;&nbsp;IP State : <span style=\"color:#235B00\">" . $region . "</span><br />";
            echo "&bull;&nbsp;IP Country : <span style=\"color:#235B00\">" . $country . "</span><br />";
            echo "&bull;&nbsp;IP Area Code : <span style=\"color:#235B00\">" . $areacode;
            echo "</span></div></td>";
            */
            //php info
            if($serverdebug == '1' || $serverdebug == 1){
                if(phpversion() > 5){$php_ver = "<span style=\"color:#235B00\">".phpversion();}else{$php_ver = "<span style=\"color:#bb0000\">".phpversion();}
                echo "<td><div class=\"outer\"><span class=\"header\">PHP Info</span><br /><br /><p><span style=\"color:#235B00\">" . $_SERVER['SERVER_NAME'] . "</span> is using php version ". $php_ver . "</span></p>";
                if (!function_exists('http_build_query')) {echo "<span style=\"color:#bb0000\">http_build_query : No</span><br />\n";} else {echo "<span style=\"color:#235B00\">http_build_query : Yes</span><br />\n";}
                if (!function_exists('stream_context_create')) {echo "<span style=\"color:#bb0000\">stream_context_create : No</span><br />\n";} else {echo "<span style=\"color:#235B00\">stream_context_create : Yes</span><br />\n";}
                if (!function_exists('fopen')) {echo "<span style=\"color:#bb0000\">fopen : No</span><br />\n";} else {echo "<span style=\"color:#235B00\">fopen : Yes</span><br />\n";}
                if (!function_exists('file_get_contents')) {echo "<span style=\"color:#bb0000\">file_get_contents : No</span><br />\n";} else {echo "<span style=\"color:#235B00\">file_get_contents : Yes</span><br />\n";}
            } else {
                echo "<td><div class=\"outer\"><span class=\"header\">PHP Info</span><br /><br /><span style=\"color:#bb0000\">Debug Mode Disabled</span>";
            }
            echo "<div>Connected Server: $connected</div>";
            echo "<div>Server Response: $serverResponse</div></div></td></tr></table></div>";
            //timers
            echo '<p style="width: 700px; margin-left:auto; margin-right: auto; text-align:center">';
            echo "SecureLive timer: <b>$totaltime</b> seconds.";
            echo '</p>';
            die();
        }
        function sl_get_filter($str){
            $remove = '#$%^&*()|{}[]`~\\;\'"';
            $newstr = '';
            for($i=0; $i<strlen($str); $i++){
                $chr = substr($str,$i,1);
                if(!substr_count($remove, $chr)){
                    $newstr .= $chr;
                }
            }
            return $newstr;
        }
        function sl_post_request($purl, $data) {
            global $connected;
            $fp = null; $res_array = array();
            $url1 = "http://www.securelivesw.com/securelive";
            $url2 = "http://www.securelivehosting.com/slbackup";
            if($data != 'file'){ // curl or fopen
                $connected = false;
                if(function_exists('curl_init')){
                    for($i=0;$i<=15 && !$connected;$i+=5){//for each timeout interval
                        $timeout = $i==0 ? 1 : $i;
                        for($j=1;$j<=2;$j++){//for each server
                            $ctx = $data;
                            $ch = curl_init(${'url'.$j}."/$purl");
                            curl_setopt($ch, CURLOPT_POSTFIELDS, $ctx);            //send post data
                            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);        // return web page
                            curl_setopt($ch, CURLOPT_HEADER, false);            // don't return headers
                            curl_setopt($ch, CURLOPT_FOLLOWLOCATION, false);    // dont follow redirects
                            curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, $timeout);        // timeout on connect
                            curl_setopt($ch, CURLOPT_TIMEOUT, $timeout);                // timeout on response
                            curl_setopt($ch, CURLOPT_ENCODING, "");                // handle all encodings
                            curl_setopt($ch, CURLOPT_USERAGENT, "");            // who am i
                            $response = curl_exec($ch);
                            if($response){
                                $connected = "Server $j using curl";
                                curl_close($ch);
                                break;
                            }
                            curl_close($ch);
                        }
                    }
                    if(!$response){
                        $connected = "Could not connect to any server using curl!";
                    }
                } elseif (function_exists('fopen')) {
                    $old = ini_get('default_socket_timeout');
                    ini_set("allow_url_fopen", "1");
                    $params = array('http' => array('method' => 'POST', 'content' => $data));
                    $ctx = stream_context_create($params);
                    for($i=0;$i<=15 && !$connected;$i+=5){//for each timeout interval
                        $timeout = $i==0 ? 1 : $i;
                        ini_set('default_socket_timeout', $timeout);
                        for($j=1;$j<=2;$j++){//for each server
                            $fp = @fopen(${'url'.$j}."/".$purl, 'rb', false, $ctx);
                            if($fp){
                                $connected = "Server $j using fopen";
                                break;
                            }
                        }
                    }
                    ini_set('default_socket_timeout', $old);
                    if(!$fp){
                        $connected = "Could not connect to any server! using fopen";
                    }
                    $response = stream_get_contents($fp);
                    fclose($fp);
                }
                $res_array = substr_count($response, "|") ? explode("|", $response) : array($response);
                return $res_array;
            } elseif($data == 'file'){ // file
                if(function_exists('curl_init')){
                    $gotfile = false;
                    for($i=0;$i<=15 && !$gotfile;$i+=5){//for each timeout interval
                        $timeout = $i==0 ? 1 : $i;
                        for($j=1;$j<=2;$j++){//for each server
                            $ctx = $data;
                            $ch = curl_init(${'url'.$j}."/$purl");
                            curl_setopt($ch, CURLOPT_POSTFIELDS, $ctx);            //send post data
                            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);        // return web page
                            curl_setopt($ch, CURLOPT_HEADER, false);            // don't return headers
                            curl_setopt($ch, CURLOPT_FOLLOWLOCATION, false);    // dont follow redirects
                            curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, $timeout);        // timeout on connect
                            curl_setopt($ch, CURLOPT_TIMEOUT, $timeout);                // timeout on response
                            curl_setopt($ch, CURLOPT_ENCODING, "");                // handle all encodings
                            curl_setopt($ch, CURLOPT_USERAGENT, "");            // who am i
                            $response = curl_exec($ch);
                            if($response){
                                $gotfile = true;
                                curl_close($ch);
                                break;
                            }
                            curl_close($ch);
                        }
                    }
                    if(!$response){$gotfile = false;}
                    $resp = explode("\n", $response);
                } else {
                    $resp = @file($url1."/".$purl);
                    if(!$resp){$resp = @file($url2."/".$purl);}
                }
                return $resp;
            }
        }
        class InputFilter_SL {
            protected $tagsArray;    // default = empty array
            protected $attrArray;    // default = empty array

            protected $tagsMethod;    // default = 0
            protected $attrMethod;    // default = 0

            protected $xssAuto;     // default = 1
            protected $tagBlacklist = array('applet', 'body', 'bgsound', 'base', 'basefont', 'embed', 'frame', 'frameset', 'head', 'html', 'id', 'iframe', 'ilayer', 'layer', 'link', 'meta', 'name', 'object', 'script', 'style', 'title', 'xml');
            protected $attrBlacklist = array('action', 'background', 'codebase', 'dynsrc', 'lowsrc');  // also will strip ALL event handlers
                
            public function __construct($tagsArray = array(), $attrArray = array(), $tagsMethod = 0, $attrMethod = 0, $xssAuto = 1) {        
                // make sure user defined arrays are in lowercase
                for ($i = 0; $i < count($tagsArray); $i++) $tagsArray[$i] = strtolower($tagsArray[$i]);
                for ($i = 0; $i < count($attrArray); $i++) $attrArray[$i] = strtolower($attrArray[$i]);
                // assign to member vars
                $this->tagsArray = (array) $tagsArray;
                $this->attrArray = (array) $attrArray;
                $this->tagsMethod = $tagsMethod;
                $this->attrMethod = $attrMethod;
                $this->xssAuto = $xssAuto;
            }
            
            public function process($source) {
                // clean all elements in this array
                if (is_array($source)) {
                    foreach($source as $key => $value)
                        // filter element for XSS and other 'bad' code etc.
                        if (is_string($value)) $source[$key] = $this->remove($this->decode($value));
                    return $source;
                // clean this string
                } else if (is_string($source)) {
                    // filter source for XSS and other 'bad' code etc.
                    return $this->remove($this->decode($source));
                // return parameter as given
                } else return $source;    
            }

            protected function remove($source) {
                $loopCounter=0;
                // provides nested-tag protection
                while($source != $this->filterTags($source)) {
                    $source = $this->filterTags($source);
                    $loopCounter++;
                }
                return $source;
            }    
            
            protected function filterTags($source) {
                // filter pass setup
                $preTag = NULL;
                $postTag = $source;
                // find initial tag's position
                $tagOpen_start = strpos($source, '<');
                // interate through string until no tags left
                while($tagOpen_start !== FALSE) {
                    // process tag interatively
                    $preTag .= substr($postTag, 0, $tagOpen_start);
                    $postTag = substr($postTag, $tagOpen_start);
                    $fromTagOpen = substr($postTag, 1);
                    // end of tag
                    $tagOpen_end = strpos($fromTagOpen, '>');
                    //SL MODS
                    $tagOpen_end = $tagOpen_end===false ? strpos($fromTagOpen, ' ') : $tagOpen_end;
                    $tagOpen_end = $tagOpen_end===false ? strlen($fromTagOpen) : $tagOpen_end;
                    // next start of tag (for nested tag assessment)
                    $tagOpen_nested = strpos($fromTagOpen, '<');
                    if (($tagOpen_nested !== false) && ($tagOpen_nested < $tagOpen_end)) {
                        $preTag .= substr($postTag, 0, ($tagOpen_nested+1));
                        $postTag = substr($postTag, ($tagOpen_nested+1));
                        $tagOpen_start = strpos($postTag, '<');
                        continue;
                    } 
                    $tagOpen_nested = (strpos($fromTagOpen, '<') + $tagOpen_start + 1);
                    $currentTag = substr($fromTagOpen, 0, $tagOpen_end);
                    $tagLength = strlen($currentTag);
                    if (!$tagOpen_end) {
                        $preTag .= $postTag;
                        $tagOpen_start = strpos($postTag, '<');            
                    }
                    // iterate through tag finding attribute pairs - setup
                    $tagLeft = $currentTag;
                    $attrSet = array();
                    $currentSpace = strpos($tagLeft, ' ');
                    // is end tag
                    if (substr($currentTag, 0, 1) == "/") {
                        $isCloseTag = TRUE;
                        list($tagName) = explode(' ', $currentTag);
                        $tagName = substr($tagName, 1);
                    // is start tag
                    } else {
                        $isCloseTag = FALSE;
                        list($tagName) = explode(' ', $currentTag);
                    }        
                    // excludes all "non-regular" tagnames OR no tagname OR remove if xssauto is on and tag is blacklisted
                    if ((!preg_match("/^[a-z][a-z0-9]*$/i",$tagName)) || (!$tagName) || ((in_array(strtolower($tagName), $this->tagBlacklist)) && ($this->xssAuto))) {                 
                        $postTag = substr($postTag, ($tagLength + 2));
                        $tagOpen_start = strpos($postTag, '<');
                        // don't append this tag
                        continue;
                    }
                    // this while is needed to support attribute values with spaces in!
                    while ($currentSpace !== FALSE) {
                        $fromSpace = substr($tagLeft, ($currentSpace+1));
                        $nextSpace = strpos($fromSpace, ' ');
                        $openQuotes = strpos($fromSpace, '"');
                        $closeQuotes = strpos(substr($fromSpace, ($openQuotes+1)), '"') + $openQuotes + 1;
                        // another equals exists
                        if (strpos($fromSpace, '=') !== FALSE) {
                            // opening and closing quotes exists
                            if (($openQuotes !== FALSE) && (strpos(substr($fromSpace, ($openQuotes+1)), '"') !== FALSE))
                                $attr = substr($fromSpace, 0, ($closeQuotes+1));
                            // one or neither exist
                            else $attr = substr($fromSpace, 0, $nextSpace);
                        // no more equals exist
                        } else $attr = substr($fromSpace, 0, $nextSpace);
                        // last attr pair
                        if (!$attr) $attr = $fromSpace;
                        // add to attribute pairs array
                        $attrSet[] = $attr;
                        // next inc
                        $tagLeft = substr($fromSpace, strlen($attr));
                        $currentSpace = strpos($tagLeft, ' ');
                    }
                    // appears in array specified by user
                    $tagFound = in_array(strtolower($tagName), $this->tagsArray);            
                    // remove this tag on condition
                    if ((!$tagFound && $this->tagsMethod) || ($tagFound && !$this->tagsMethod)) {
                        // reconstruct tag with allowed attributes
                        if (!$isCloseTag) {
                            $attrSet = $this->filterAttr($attrSet);
                            $preTag .= '<' . $tagName;
                            for ($i = 0; $i < count($attrSet); $i++)
                                $preTag .= ' ' . $attrSet[$i];
                            // reformat single tags to XHTML
                            if (strpos($fromTagOpen, "</" . $tagName)) $preTag .= '>';
                            else $preTag .= ' />';
                        // just the tagname
                        } else $preTag .= '</' . $tagName . '>';
                    }
                    // find next tag's start
                    $postTag = substr($postTag, ($tagLength + 2));
                    $tagOpen_start = strpos($postTag, '<');            
                }
                // append any code after end of tags
                $preTag .= $postTag;
                return $preTag;
            }

            protected function filterAttr($attrSet) {    
                $newSet = array();
                // process attributes
                for ($i = 0; $i <count($attrSet); $i++) {
                    // skip blank spaces in tag
                    if (!$attrSet[$i]) continue;
                    // split into attr name and value
                    $attrSubSet = explode('=', trim($attrSet[$i]));
                    list($attrSubSet[0]) = explode(' ', $attrSubSet[0]);
                    // removes all "non-regular" attr names AND also attr blacklisted
                    if ((!eregi("^[a-z]*$",$attrSubSet[0])) || (($this->xssAuto) && ((in_array(strtolower($attrSubSet[0]), $this->attrBlacklist)) || (substr($attrSubSet[0], 0, 2) == 'on')))) 
                        continue;
                    // xss attr value filtering
                    if ($attrSubSet[1]) {
                        // strips unicode, hex, etc
                        $attrSubSet[1] = str_replace('&#', '', $attrSubSet[1]);
                        // strip normal newline within attr value
                        $attrSubSet[1] = preg_replace('/\s+/', '', $attrSubSet[1]);
                        // strip double quotes
                        $attrSubSet[1] = str_replace('"', '', $attrSubSet[1]);
                        // [requested feature] convert single quotes from either side to doubles (Single quotes shouldn't be used to pad attr value)
                        if ((substr($attrSubSet[1], 0, 1) == "'") && (substr($attrSubSet[1], (strlen($attrSubSet[1]) - 1), 1) == "'"))
                            $attrSubSet[1] = substr($attrSubSet[1], 1, (strlen($attrSubSet[1]) - 2));
                        // strip slashes
                        $attrSubSet[1] = stripslashes($attrSubSet[1]);
                    }
                    // auto strip attr's with "javascript:
                    if (    ((strpos(strtolower($attrSubSet[1]), 'expression') !== false) &&    (strtolower($attrSubSet[0]) == 'style')) ||
                            (strpos(strtolower($attrSubSet[1]), 'javascript:') !== false) ||
                            (strpos(strtolower($attrSubSet[1]), 'behaviour:') !== false) ||
                            (strpos(strtolower($attrSubSet[1]), 'vbscript:') !== false) ||
                            (strpos(strtolower($attrSubSet[1]), 'mocha:') !== false) ||
                            (strpos(strtolower($attrSubSet[1]), 'livescript:') !== false) 
                    ) continue;

                    // if matches user defined array
                    $attrFound = in_array(strtolower($attrSubSet[0]), $this->attrArray);
                    // keep this attr on condition
                    if ((!$attrFound && $this->attrMethod) || ($attrFound && !$this->attrMethod)) {
                        // attr has value
                        if ($attrSubSet[1]) $newSet[] = $attrSubSet[0] . '="' . $attrSubSet[1] . '"';
                        // attr has decimal zero as value
                        else if ($attrSubSet[1] == "0") $newSet[] = $attrSubSet[0] . '="0"';
                        // reformat single attributes to XHTML
                        else $newSet[] = $attrSubSet[0] . '="' . $attrSubSet[0] . '"';
                    }    
                }
                return $newSet;
            }
            
            protected function decode($source) {
                // url decode
                $source = html_entity_decode($source, ENT_QUOTES, "ISO-8859-1");
                // convert decimal
                $source = preg_replace('/&#(\d+);/me',"chr(\\1)", $source);                // decimal notation
                // convert hex
                $source = preg_replace('/&#x([a-f0-9]+);/mei',"chr(0x\\1)", $source);    // hex notation
                return $source;
            }

            public function safeSQL($source, &$connection) {
                // clean all elements in this array
                if (is_array($source)) {
                    foreach($source as $key => $value)
                        // filter element for SQL injection
                        if (is_string($value)) $source[$key] = $this->quoteSmart($this->decode($value), $connection);
                    return $source;
                // clean this string
                } else if (is_string($source)) {
                    // filter source for SQL injection
                    if (is_string($source)) return $this->quoteSmart($this->decode($source), $connection);
                // return parameter as given
                } else return $source;    
            }

            protected function quoteSmart($source, &$connection) {
                // strip slashes
                if (get_magic_quotes_gpc()) $source = stripslashes($source);
                // quote both numeric and text
                $source = $this->escapeString($source, $connection);
                return $source;
            }
            
            protected function escapeString($string, &$connection) {
                // depreciated function
                if (version_compare(phpversion(),"4.3.0", "<")) mysql_escape_string($string);
                // current function
                else mysql_real_escape_string($string);
                return $string;
            }
        }
        function sl_is_admin(){
            $uri = isset($_SERVER['REQUEST_URI']) ? $_SERVER['REQUEST_URI'] : getenv('REQUEST_URI');
            $admins = array('/administrator','/wp-admin','/securelive_max','/sl_admin');
            foreach($admins as $txt){
                if(substr_count($uri,$txt)){
                    return true;
                }
            }
            return false;
        }
    }
    include_once('domainchk.php');
    global $redirect, $totaltime, $sttime, $serverResponse, $connected;
    $redirect = null;
    if(someoneIsHacking()){dontLetThemIn($redirect);}
    if(!sl_is_admin()){
        $myFilter = new InputFilter_SL();
        $_POST = $myFilter->process($_POST);
    }
    if(youWantDiagnostics()){youGetDiagnostics();}
    
?>